unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, JvSimpleXml, ExtCtrls;

type
  TForm1 = class(TForm)
    tv: TTreeView;
    JvSimpleXML: TJvSimpleXML;
    Panel: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure tvStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure tvDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure tvDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure tvClick(Sender: TObject);
    procedure tvKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    tnDrag : tTreeNode;
    function ErzeugeTV(aTN : tTreeNode; elXML : tJvSimpleXMLElems) : tTreeNode;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1.ErzeugeTV(aTN: tTreeNode; elXML: tJvSimpleXMLElems): tTreeNode;
Var
  i : Integer;
  S : String;
begin
  For i:=0 to elXML.Count - 1 do
    If elXML[i].Name = 'Tabelle' then
      ErzeugeTV(tv.Items.AddChildObject(aTN,elXML[i].Properties.ItemNamed['Name'].Value,elXML[i]),elXML[i].Items)
    else
      If (elXML[i].Name = 'Karteireiter') or
         (elXML[i].Name = 'Gruppe') or
         (elXML[i].Name = 'Menu') or
         (elXML[i].Name = 'MenuItem') then  // gibts Property Name und event. <Sprache>
      begin
        S:=elXML[i].Properties.ItemNamed['Name'].Value;
        ErzeugeTV(tv.Items.AddChildObject(aTN,S,elXML[i]),elXML[i].Items);
      end
      else
        If (elXML[i].Name = 'Feld') or (elXML[i].Name = 'Button') or (elXML[i].Name = 'MenuItem') then
          tv.Items.AddChildObject(aTN,elXML[i].Properties.ItemNamed['Name'].Value,elXML[i]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  jvSimpleXML.LoadFromFile('Konfiguration.xml');
  ErzeugeTV(tv.Items.AddChild(nil,'Tabellen'),jvSimpleXML.Root.Items.ItemNamed['Tabellen'].Items);
end;



procedure TForm1.tvStartDrag(Sender: TObject; var DragObject: TDragObject);
begin
  tnDrag:=tv.Selected;
end;

procedure TForm1.tvDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  tnNach : tTreeNode;

  function HoleTabelle(aXMLElem : tJvSimpleXMLElem) : String;
  begin
    If Assigned(aXMLElem) then
      If aXMLElem.Name = 'Tabelle' then
        Result:=aXMLElem.Properties.ItemNamed['Name'].Value  // Tabelle hat immer Name
      else
        Result:=HoleTabelle(aXMLElem.Parent)
    else
      Result:='';
  end;

begin
  inherited;
  Accept:=FALSE;

  tnNach:=tv.GetNodeAt(x,y);
  If Assigned(tnNach) and Assigned(tnNach.Data) and Assigned(tnDrag.Data) and (tnDrag <> tnNach) then
  With tJvSimpleXMLElem(tnDrag.Data) do
    If HoleTabelle(tnDrag.Data) = HoleTabelle(tnNach.Data) then
      Accept:=(Name <> 'Menu') and (tJvSimpleXMLElem(tnNach.Data).Name <> 'Menu') and
              ((Name <> 'MenuItem') or (tJvSimpleXMLElem(tnNach.Data).Name = 'MenuItem')) and
              ((Name <> 'Karteireiter') or (tJvSimpleXMLElem(tnNach.Data).Name = 'Karteireiter')) and
              ((Name <> 'Aktion') or (tJvSimpleXMLElem(tnNach.Data).Name = 'Aktion') or
               (tJvSimpleXMLElem(tnNach.Data).Name = 'Sektion') and (tnNach.Level > 1))
    else
      Accept:=(Name = 'Tabelle') and (tJvSimpleXMLElem(tnNach.Data).Name = 'Tabelle');
end;

procedure TForm1.tvDragDrop(Sender, Source: TObject; X, Y: Integer);
Var
  tnNach : tTreeNode;
  xml1,xml2,xmlTemp : tJvSimpleXMLElem;

begin  { DragDrop }
  inherited;

  tnNach:=tv.GetNodeAt(x,y);

  xml1:=tJvSimpleXMLElem(tnDrag.Data);
  xml2:=tJvSimpleXMLElem(tnNach.Data);

  // zunchst die Knoten aus einer Ebene und gleichem Ast
  If (xml1.Parent = xml2.Parent) and
     ((xml1.Name = xml2.Name) or
      (xml1.Name = 'Gruppe') and (xml2.Name = 'Feld')) then  // Reihenfolge verndern
  begin
    xml1.Parent.Items.Move(xml1.Parent.GetChildIndex(xml1),
                           xml2.Parent.GetChildIndex(xml2));
    tnDrag.MoveTo(tnNach,naInsert);
  end
  else  // Elemente aus verschiedenen Karteireitern bzw. Gruppen
  begin
    xml2.Parent.Items.Add(xml1);
    tnDrag.MoveTo(tnNach,naInsert);
  end;
  tvClick(nil);
end;

procedure TForm1.tvClick(Sender: TObject);
Var
  el : tJvSimpleXMLElem;
begin
  Panel.Caption:='';
  If tv.Selected <> nil then
  begin
    el:=tJvSimpleXMLElem(tv.Selected.Data);
    If Assigned(el) and Assigned(el.Parent) then
      panel.caption:='Parent hat ' + inttostr(el.Parent.Items.Count) + ' Elemente';
  end;
end;

procedure TForm1.tvKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  tvclick(Sender);
end;

end.
